<?php 
	// The Simple PHP Blog is released under the GNU Public License.
	//
	// You are free to use and modify the Simple PHP Blog. All changes 
	// must be uploaded to SourceForge.net under Simple PHP Blog or
	// emailed to apalmo <at> bigevilbrain <dot> com

	// ----------------
	// Cloud Functions
	// ----------------
	function cloud ( ) {	
		define("MIN_SIZE", 14);
		define("MAX_SIZE", 36);

		// Read entries to generate the cloud file
		// Used for the main Index page.
		global $lang_string, $blog_config, $user_colors;
		
		// To avoid server overload
		sleep(1);
		$max_results=10;
		$output_str = '';
		
		$entry_file_array = blog_entry_listing();

		if ( 2> 1) {
		
			if ( $max_results <= 0 ) {
				$max_results=10;
			}
			
			$results=0;
			// Loop through entry files			
			
			$min = 1;
			$max = -MAX_INT;
			$min_size = MIN_SIZE;
			$max_size = MAX_SIZE;

			$tags[0][0]="";
			$tags[0][1]=0;
			
			for ( $i = 0; $i < count( $entry_file_array ); $i++ ) {
				if ( $results > $max_results ) {
					break;
				}
			
				list( $entry_filename, $year_dir, $month_dir ) = explode( '|', $entry_file_array[ $i ] );
				$contents = sb_read_file( 'content/' . $year_dir . '/' . $month_dir . '/' . $entry_filename );
				$j = 0;
				$found = true;
				$text = strtoupper( $contents );

				$contents=strstr($contents,'relatedlink|');				
				
				$contents=explode('|', $contents );				
				$words=explode(',', $contents[1] );								

				foreach ($words as $tag) {				
					$tags=ajout_array($tags,$tag);
				}											
			}
		}
		
		//max and min
		$i=1;
		while ($i<$tags[0][1]){
			if ($tags[$i][1] < $min) $min = $tags[$i][1];
		    if ($tags[$i][1] > $max) $max = $tags[$i][1];
			$i++;
		}
		
		//Output
		$i=1;
		$output_str ="";		
		while ($i<$tags[0][1]){			
			$iSize=intval($min_size + (($tags[$i][1] - $min) * (($max_size - $min_size) / ($max - $min))));		
			//$iSize=$iSize+5;
			$output_str =$output_str .'<a href="search.php?q='. $tags[$i][0] .'" style="font-size:'. $iSize.'px" title="'. $tags[$i][0]. '">'.$tags[$i][0].'</a> &nbsp;&nbsp; ';

		   $i++;
		}

		//Cloud Creation
		$inF = fopen('cloud.inc','w');
		fputs($inF,$output_str );
		fclose($inF);

		//return ( $output_str );
	}
	
function ajout_array($tags,$tag){
	//Ajoute le mot dans un tableau si il n y est pas deja
	//add word in an array if it isn't already in
	$tag=trim($tag);
	if ($tag!=''){
		$bTrouve=false;
		$i=1;		
		while ($bTrouve==false and $i<$tags[0][1]){
			if ($tags[$i][0]==$tag){
				$bTrouve=true;
				$tags[$i][1]=$tags[$i][1]+1;
			}
			$i++;
		}
		
		if ($bTrouve==false){
			$tags[$i][0]=$tag;
			$tags[$i][1]=1;
			$tags[0][1]=$tags[0][1]+1;
		}
	}
	
	return $tags;
}
?>