<?php 
	require_once('scripts/sb_functions.php');	
	require_once('scripts/sb_cloud.php');
		
	global $logged_in;
	$logged_in = logged_in( false, true );
	
	read_config();
	
	require_once('languages/' . $blog_config[ 'blog_language' ] . '/strings.php');
	sb_language( 'search' );

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=<?php echo( $lang_string[ 'html_charset' ] ); ?>" />
	
	<link rel="stylesheet" type="text/css" href="themes/<?php echo( $blog_theme ); ?>/style.css" />
	<?php require_once('themes/' . $blog_theme . '/user_style.php'); ?>
	<?php require_once('scripts/sb_javascript.php'); ?>
	<script language="javascript" src="scripts/sb_javascript.js" type="text/javascript"></script>
	
	<title><?php echo($blog_config[ 'blog_title' ]); ?></title>
</head>
<?php 
	function page_content() {
		global $lang_string, $user_colors, $search_string, $logged_in, $theme_vars, $blog_theme;
		$entry_array = array();
		$entry_array[ 'subject' ] = "Nuage de tags";
		ob_start(); ?>
		<?php

		//You have 2 parameters in cloud.php 		
		//define("MIN_SIZE", 3);
		//define("MAX_SIZE", 36);

		if (file_exists('cloud.inc')){	
			include_once('cloud.inc');
		}else{
			cloud();		
			include_once('cloud.inc');
		}

		$entry_array[ 'entry' ] = ob_get_clean();
		echo( theme_staticentry( $entry_array ) );	
	}
?>
<?php 
	theme_pagelayout();
?>
</html>